/// <reference types="node" />
import * as proxy from 'http-proxy-middleware';
import { SMAbstractResponse, SMAbstractNext, SMValidateInfo, ProxyHandleConfig } from '../consts';
/**
 * @description 双向校验
 */
export declare function createValidateMiddle(hooks?: SMAbstractNext): <Req extends import("http").IncomingMessage, Res extends SMAbstractResponse, Next extends SMAbstractNext>(req: Req, res: Res, next?: Next | undefined) => Promise<void>;
export declare const responseHooksFactory: (cb: (res: {
    code: number;
    message?: string | undefined;
    result: SMValidateInfo;
}) => any) => (req: import("http").IncomingMessage, res: SMAbstractResponse) => Promise<void>;
/**
 * @description 劫持 webpackDevServer proxy 配置，以获取参数及相应
 * @param proxies
 * @param config
 */
export declare function proxyHandle(
/** 单个或多个代理 */
proxies: proxy.Config[] | proxy.Config, 
/** 配置信息 */
config: ProxyHandleConfig): proxy.Config[];
