import Ajv from 'ajv';
import { SwaggerJson, SMValidator, SMSchema, PathJson } from '../consts';
/** 将 swagger 转成 ajv */
export declare const getAJV: (swagger: SwaggerJson) => Ajv.Ajv;
/** 根据 base path 获取 swagger 文件 */
export declare function getSwagger(basePath: string): SwaggerJson;
/** 获取 swagger definitions 字段 */
export declare function getDefinitions(swagger: SwaggerJson): import("json-schema").JSONSchema4 | import("json-schema").JSONSchema6 | undefined;
/** 根据 path 从 swagger paths 内获取接口定义 */
export declare function getPath(swagger: SwaggerJson, path: string): {
    [method: string]: PathJson;
};
/** 将 swagger parameters 转换成 schema */
export declare function getParamSchema(parameters: PathJson['parameters']): SMSchema;
export declare const validatorFactory: (ajv: Ajv.Ajv) => <D extends {}>(shema: SMSchema, data: D) => string;
/** @tkit/ajax 规范的数据响应的校验 */
export declare const defaultValidator: SMValidator;
