/* eslint-disable @typescript-eslint/no-non-null-assertion */
/**
 * @description 增量更新操作界面逻辑
 */
{
    /* eslint-disable no-undef */
    var title = (document.title = 'swagger 增量同步工具');
    var ChangedClassName_1 = 'select-change';
    var keySeparator_1 = '@@__S__@@';
    var canvas_1 = document.querySelector('#canvas');
    var menu = document.querySelector('#menu');
    canvas_1.innerHTML = jsondiffpatch.formatters.html.format(delta, curVersion);
    /** 隐藏未修改 */
    function hide() {
        jsondiffpatch.formatters.html.hideUnchanged();
    }
    /** 显示未修改 */
    function show() {
        jsondiffpatch.formatters.html.showUnchanged();
    }
    // eslint-disable-next-line @typescript-eslint/no-unused-vars
    function toggleUnchanged(me) {
        var checked = me.checked;
        if (checked) {
            show();
        }
        else {
            hide();
        }
    }
    function toggleSelectAll(me) {
        var checked = me.checked;
        var allChangedInput = document.querySelectorAll("." + ChangedClassName_1);
        var deletedExcluded = document.getElementById('仅不选择删除').checked;
        var addedIncluded = document.getElementById('仅选择新增').checked;
        if (allChangedInput) {
            [].forEach.call(allChangedInput, function (node) {
                if ((deletedExcluded &&
                    node.parentNode.className.indexOf('-deleted') !== -1) ||
                    (addedIncluded && node.parentNode.className.indexOf('-added') === -1)) {
                    // 排除
                    node.checked = false;
                }
                else {
                    node.checked = checked;
                }
            });
        }
        setCount();
    }
    /** 仅不选择删除 */
    // eslint-disable-next-line @typescript-eslint/no-unused-vars
    function excludeDelete(me) {
        setTimeout(function () {
            var all = document.getElementById('全选/取消全选');
            all.checked = true;
            toggleSelectAll(all);
        });
    }
    /** 仅选择新增 */
    // eslint-disable-next-line @typescript-eslint/no-unused-vars
    function onlyAdd(me) {
        setTimeout(function () {
            var all = document.getElementById('全选/取消全选');
            all.checked = true;
            toggleSelectAll(all);
        });
    }
    /** 显示选中修改状态 */
    // eslint-disable-next-line @typescript-eslint/no-unused-vars
    function showStatus(me) {
        var addedEle = document.getElementById('仅显示新增');
        var deletedEle = document.getElementById('仅显示删除');
        var modifiedEle = document.getElementById('仅显示修改');
        var propertyNameEle = document.getElementById('仅显示属性名');
        if (me !== propertyNameEle) {
            if (me === modifiedEle) {
                addedEle.checked = false;
                deletedEle.checked = false;
            }
            else {
                modifiedEle.checked = false;
            }
        }
        var added = addedEle.checked;
        var deleted = deletedEle.checked;
        var modified = modifiedEle.checked;
        var addedAndDeleted = added && deleted;
        var propertyNameOnly = propertyNameEle.checked;
        document.getElementById('canvas').className = "" + (modified
            ? 'show-modified-only canvas'
            : addedAndDeleted
                ? 'show-added-deleted-only canvas'
                : added
                    ? 'show-added-only canvas'
                    : deleted
                        ? 'show-add-deleted canvas'
                        : 'canvas') + (propertyNameOnly ? ' show-only-property-name' : '');
    }
    var help = "<div class=\"help-info\" id=\"help-info\" style=\"display: none;\">\n  <b>\u67E5\u770B\u66F4\u65B0\u4FE1\u606F</b>\n  <p>\n  \u901A\u8FC7\u201C\u663E\u793A*\u201D\u76F8\u5173\u7684\u9009\u62E9\u6846\uFF0C\u53EA\u67E5\u770B\u6211\u4EEC\u771F\u6B63\u5173\u6CE8\u7684\u4FE1\u606F\uFF0C\u6BD4\u5982\u201C\u4EC5\u663E\u793A\u5220\u9664\u201D\u3001\u201C\u4EC5\u663E\u793A\u65B0\u589E\u201D\u3002\n  </p>\n  <p>\n  \u901A\u8FC7\u201C\u4EC5\u663E\u793A\u5C5E\u6027\u540D\u201D\uFF0C\u67E5\u770B\u53D8\u66F4\u6982\u89C8\uFF0C\u6BD4\u5982\u201Cpaths\u201D\u3001\u201Cdefinitions\u201D\u5173\u952E\u8282\u70B9\u4E0A\uFF0C\u6709\u591A\u5C11\u5185\u5BB9\u65B0\u589E\u3001\u5220\u9664\u3002\n  </p>\n  <b>\u589E\u91CF\u66F4\u65B0</b>\n  <p>\n  \u901A\u8FC7\u201C\u9009\u62E9*\u201D\u76F8\u5173\u7684\u9009\u62E9\u6846\uFF0C\u9009\u62E9\u6027\u540C\u6B65\u8FDC\u7AEFSwagger\u6587\u6863\u5DEE\u5F02\u5230\u672C\u5730\uFF0C\u6BD4\u5982\u5728\u540E\u7AEF\u591A\u5206\u652F\u5E76\u884C\u5F00\u53D1\u7684\u60C5\u51B5\u4E0B\uFF0C\u4F1A\u51FA\u73B0\u201C\u8BEF\u5220\u9664\u201D\u5DEE\u5F02\uFF0C\u8FD9\u4E2A\u65F6\u5019\u53EF\u4EE5\u901A\u8FC7\u201C\u4EC5\u4E0D\u9009\u62E9\u5220\u9664\u201D\u6765\u540C\u6B65\u9664\u4E86\u5220\u9664\u4E4B\u5916\u7684\u6240\u6709\u5DEE\u5F02\u3002\n  </p>\n  <b>\u793E\u533A\u652F\u6301</b>\n  <p>wx+: skipper_yqj</p>\n  </div>";
    // eslint-disable-next-line @typescript-eslint/no-unused-vars
    function toggleHelp(e) {
        e.stopImmediatePropagation();
        var helpInfo = document.getElementById('help-info');
        if (helpInfo) {
            helpInfo.style.display = helpInfo.style.display === 'none' ? 'block' : 'none';
            helpInfo.onclick = function (e) {
                e.stopImmediatePropagation();
            };
        }
    }
    document.body.onclick = function () {
        var helpInfo = document.getElementById('help-info');
        if (helpInfo) {
            helpInfo.style.display = 'none';
        }
    };
    menu.innerHTML =
        [
            [
                '仅显示新增',
                'showStatus',
                '',
                '',
                "(" + document.querySelectorAll('.jsondiffpatch-added').length + "\u5904)"
            ],
            [
                '仅显示删除',
                'showStatus',
                '',
                '',
                "(" + document.querySelectorAll('.jsondiffpatch-deleted').length + "\u5904)"
            ],
            [
                '仅显示修改',
                'showStatus',
                '',
                '',
                "(" + document.querySelectorAll('.jsondiffpatch-modified').length + "\u5904)"
            ],
            ['显示未变更', 'toggleUnchanged'],
            ['仅显示属性名', 'showStatus'],
            ['全选/取消全选', 'toggleSelectAll'],
            ['仅不选择删除', 'excludeDelete'],
            ['仅选择新增', 'onlyAdd'],
            ['同步已选择更新', 'patch', '', 'button']
        ].reduce(function (html, item) {
            var zero = item[0], callback = item[1], three = item[2], tagName = item[3], extra = item[4];
            var name = zero || three;
            html += tagName
                ? "\n      <button id=\"" + name + "\" onClick=\"" + callback + "(this)\" type=\"checkbox\" name=\"" + name + "\">" + name + "</button>\n    "
                : "\n    <input id=\"" + name + "\" onClick=\"" + callback + "(this)\" type=\"checkbox\" name=\"" + name + "\"><label id=\"for" + name + "\" for=\"" + name + "\">" + name + (extra !== undefined ? extra : '') + "</label>\n    ";
            return html;
        }, '') + ("<a class=\"help-icon\" onClick=\"toggleHelp(event)\">?</a>" + help);
    var counter_1 = document.createElement('div');
    counter_1.className = 'select-count';
    menu.appendChild(counter_1);
    function setCount() {
        counter_1.innerHTML = "\u5DF2\u9009\uFF1A" + getAllSelect().length + " / " + getAllChanged().length + " \u5904";
    }
    hide();
    function getKeys(node) {
        var par = node.parentNode;
        var key = node.getAttribute('data-key');
        var keys = [];
        if (key) {
            // IMP: 数组的 key 需要特殊处理，符合 json diff 协议
            if (node.className.indexOf('jsondiffpatch-deleted') !== -1 &&
                par.className.indexOf('jsondiffpatch-node-type-array') !== -1) {
                key = '_' + key;
            }
            keys.unshift(key);
            while (par && par !== canvas_1) {
                key = par.getAttribute('data-key');
                if (key) {
                    keys.unshift(key);
                }
                par = par.parentNode;
            }
        }
        return keys;
    }
    /** 所有选中的 key */
    var allSelectedIndexes_1 = [];
    /** 所有被排除的 key */
    var allExcludedIndexes_1 = [];
    function getAllSelect() {
        allSelectedIndexes_1 = [];
        allExcludedIndexes_1 = [];
        return [].filter.call(document.querySelectorAll("." + ChangedClassName_1) || [], function (item) {
            if (item.checked) {
                allSelectedIndexes_1.push(item.value.split(keySeparator_1));
            }
            else {
                allExcludedIndexes_1.push(item.value.split(keySeparator_1));
            }
            return item.checked;
        });
    }
    function getAllChanged() {
        return (document.querySelectorAll('li[data-key]:not(.jsondiffpatch-unchanged):not(.jsondiffpatch-node)') || []);
    }
    var allChanged = getAllChanged();
    [].forEach.call(allChanged, function (node) {
        var input = document.createElement('input');
        input.className = ChangedClassName_1;
        input.type = 'checkbox';
        input.value = getKeys(node).join(keySeparator_1);
        input.onchange = function () {
            setCount();
        };
        node.insertBefore(input, node.firstChild);
        var handleClick = function () {
            input.checked = !input.checked;
            setCount();
        };
        node.querySelector('.jsondiffpatch-value').onclick = handleClick;
        var key = node.querySelector('.jsondiffpatch-property-name');
        if (key) {
            key.onclick = handleClick;
        }
    });
    setCount();
    /** 让 server 端应用被选中的更新 */
    // eslint-disable-next-line @typescript-eslint/no-unused-vars
    function patch() {
        if (!allSelectedIndexes_1.length) {
            if (!confirm('忽略所有远程变动？')) {
                return;
            }
        }
        var xhr = new XMLHttpRequest();
        xhr.open('POST', '/patch');
        xhr.setRequestHeader('Content-Type', 'application/json');
        xhr.send(JSON.stringify({ version: diffVersion, keys: allSelectedIndexes_1, unkeys: allExcludedIndexes_1 }));
        xhr.onreadystatechange = function () {
            if (xhr.readyState === 4) {
                try {
                    var res = JSON.parse(xhr.response);
                    if (res.code) {
                        throw res.message;
                    }
                    else {
                        if (confirm('同步成功，可以重新生成 service 了——关闭当前窗口？')) {
                            // @IMP: f**k 2 ok
                            window.close();
                            window.close();
                        }
                    }
                }
                catch (e) {
                    alert('失败：' + (e.message || e));
                }
            }
        };
        xhr.onload = function () {
            if (xhr.status !== 200) {
                alert('同步失败');
            }
        };
        xhr.onerror = function (e) {
            alert('同步失败：' + e && e['message']);
        };
    }
}
//# sourceMappingURL=service.js.map